ZeBidData = {} -- stores all function
ZeBidData.Bids = {} -- stores all bids
local MAX_VISIBLE_BIDS = 8
local bidding = false
local newBid = true

local frame = CreateFrame("Frame")
local bidFrame

local biddingHandler, sortBids, getOfficerNote

-- create slash commands
SLASH_ZEBID_OPEN1 = "/zb"
SlashCmdList["ZEBID_OPEN"] = function(msg)
	if msg == "close" then
		ZeBid:Hide()
	elseif msg == "open" then
		ZeBid:Show()
	else
		print("Use /zb open/close")
	end
end

bidFrame = getglobal("ZeBid")
bidFrame:SetScript("OnShow", function(self, event, ...)
	bidding = true
	ZeBidData.Update()
end)
bidFrame:SetScript("OnHide", function(self, event, ...)
	bidding = false
	ZeBidData.Bids = table.wipe(ZeBidData.Bids)
	ZeBidData.Update()
end)

function biddingHandler(self, event, msg, sender)
	if bidding then
		local cmd, bid = msg:match("(%S+)%s+(.+)")
		local name, bidep, ep
		if cmd and cmd:lower() == "!bid" then
			if tonumber(bid) then
				newBid = true
				bid = tonumber(bid)
				name = sender:match("([^%-]+)")
				bidep, ep = getOfficerNote(sender)
				if bid > bidep then
					SendChatMessage("[ZeBid] You can bid maximum "..bidep, "WHISPER", nil, sender)
					return
				end
				for k, v in pairs(ZeBidData.Bids) do
					if v[1] == name then
						newBid = false
						if bid > v[2] then
							v[2] = bid
						end
					end
				end
				if newBid then
					table.insert(ZeBidData.Bids, {
						name,
						bid,
						bidep,
						ep
					})
				end
				table.sort(ZeBidData.Bids, sortBids)
				ZeBidData.Update()
				-- print("BID: "..name.." -> "..bid)
			end
		end
	end
end

frame:RegisterEvent("CHAT_MSG_WHISPER")
frame:SetScript("OnEvent", biddingHandler)

function sortBids(v1, v2)
	return v1[2] > v2[2]
end


function getOfficerNote(name)
	local _, online = GetNumGuildMembers()
	for i = 1, online do
		local gname, _, _, _, _, _, _, officernote = GetGuildRosterInfo(i)
		if gname == name then
			local bidep, ep
			ep = tonumber(officernote:match("([^%,]+)"))
			bidep = floor(ep / 2)
			return bidep, ep
		end
	end
	return 0, 0
end

-- create placeholders for visible bids
do
	local entry = CreateFrame("Button", "$parentEntry1", ZeBidTableList, "ZeBidEntry")
	entry:SetID(1)
	entry:SetPoint("TOPLEFT", 4, -28)
	for i=2, MAX_VISIBLE_BIDS do
		local entry = CreateFrame("Button", "$parentEntry"..i, ZeBidTableList, "ZeBidEntry")
		entry:SetID(i)
		entry:SetPoint("TOP", "$parentEntry"..(i-1), "BOTTOM")
	end
end

function ZeBidData.Update()
	FauxScrollFrame_Update(ZeBidTableListScrollFrame, #ZeBidData.Bids, MAX_VISIBLE_BIDS, 24, "ZeBidTableListEntry", 328, 344, ZeBidTableListHeaderEp, 60, 76)
	for i = 1, MAX_VISIBLE_BIDS do
		local entry = ZeBidData.Bids[i + ZeBidTableListScrollFrame.offset]
		local frame = getglobal("ZeBidTableListEntry"..i)
		if entry then
			frame:Show()
			getglobal(frame:GetName().."Name"):SetText(entry[1])
			getglobal(frame:GetName().."Bid"):SetText(entry[2])
			getglobal(frame:GetName().."BidEp"):SetText(entry[3])
			getglobal(frame:GetName().."Ep"):SetText(entry[4])
			if entry.isSelected then
				getglobal(frame:GetName().."BG"):Show()
			else
				getglobal(frame:GetName().."BG"):Hide()
			end
		else
			frame:Hide()
		end
	end
end

-- test
-- for i = 1, 2 * MAX_VISIBLE_BIDS do
	-- table.insert(ZeBidData.Bids, {
		-- "Test Name"..i,
		-- MAX_VISIBLE_BIDS - i,
		-- i % 3 + 1,
		-- i * 10
	-- })
-- end
ZeBidData.Update()